From 7f04e622bb1397bb927e3a6c2e4b2ab39b8e8230 Mon Sep 17 00:00:00 2001
From: Aleksandar Dimitrov <aleks.dimitrov@gmail.com>
Date: Sun, 26 Jan 2014 20:19:54 +0100
Subject: [PATCH] Fix type error in date comparison

To be fair, this is a superficial fix. I didn't go spelunking into the rest of
the code base and just assumed it'd be beneficial to actually use dates (not
unicode string values) for the comparision of a variable named date_compare.

If that's not appropriate, there might be some subtle things going wrong.
---
 scanner/PhotoAlbum.py | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

diff --git a/scanner/PhotoAlbum.py b/scanner/PhotoAlbum.py
index aeb3087..fae4e5e 100644
--- a/scanner/PhotoAlbum.py
+++ b/scanner/PhotoAlbum.py
@@ -37,9 +37,10 @@ class Album(object):
 			return self._albums[-1].date
 		elif len(self._albums) == 0:
 			return self._photos[-1].date
-		return max(self._photos[-1].date, self._albums[-1].date)
+		return max(Photo.parsedate(self._photos[-1].date), Photo.parsedate(self._albums[-1].date))
 	def __cmp__(self, other):
-		return cmp(self.date, other.date)
+		return cmp(Photo.parsedate(self.date),
+                           Photo.parsedate(other.date))
 	def add_photo(self, photo):
 		self._photos.append(photo)
 		self._photos_sorted = False
@@ -314,8 +315,16 @@ class Photo(object):
 			return self._attributes["dateTime"]
 		else:
 			return self._attributes["dateTimeFile"]
+	@staticmethod
+	def parsedate(stringordate):
+		if type(stringordate) is unicode:
+			date_format = "%Y:%m:%d %H:%M:%S"
+			return datetime.strptime(stringordate,date_format)
+		else:
+			return stringordate
 	def __cmp__(self, other):
-		date_compare = cmp(self.date, other.date)
+		date_compare = cmp(Photo.parsedate(self.date),
+		                   Photo.parsedate(other.date))
 		if date_compare == 0:
 			return cmp(self.name, other.name)
 		return date_compare
-- 
1.8.5.3

